//+------------------------------------------------------------------+
//|                                                   Pip Target.mq4 |
//|                                                 Copyright  2010 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  YellowGreen
#property indicator_color2  DarkGray
#property indicator_width1  3
#property indicator_width2  3

//--- input parameters
extern ENUM_TIMEFRAMES TimeFrame      = PERIOD_CURRENT;
extern int             ATRPeriod		  = 12;
extern int 	           HistoryLength  = 60;
extern bool            Interpolate    = true;
double PipTarget[];
double PipTargetLine[];
bool   returnBars;
string indicatorFileName;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0,PipTarget); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,PipTargetLine);
         HistoryLength     = MathMax(HistoryLength,1);
         ATRPeriod         = MathMax(ATRPeriod,1);
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" ("+ATRPeriod+")"+" ("+HistoryLength+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//
//
//
//
//

double workAtr[];

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { PipTarget[0] = limit+1; return(0); }
            if (TimeFrame!= _Period) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
            if (ArraySize(workAtr)!=HistoryLength) ArrayResize(workAtr,HistoryLength);

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         for (int k=0; k<HistoryLength; k++) workAtr[k] = iATR(NULL,TimeFrame,ATRPeriod,y+k);
         double min = workAtr[ArrayMinimum(workAtr)];
         double max = workAtr[ArrayMaximum(workAtr)];
      PipTarget[i]     = max+min-workAtr[0];
      PipTargetLine[i] = PipTarget[i];
      if (TimeFrame==_Period || !Interpolate || ((i>0) && y==iBarShift(NULL,TimeFrame,Time[(int)MathMax(i-1,0)]))) continue;

         datetime time = iTime(NULL,TimeFrame,y);
         int n,x;
         for(n = 1; (i+n)<(Bars-1) && Time[i+n] >= time; n++) continue;	
         for(x = 1; x < n && (i+x)<Bars; x++)
         {
            PipTarget[i+x]     = PipTarget[i]  + (PipTarget[i+n]  - PipTarget[i]) * x/n;
            PipTargetLine[i+x] = PipTarget[i+x];
         }               
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}